<tw_ethereum_transactions>
    <div class="content-block-title">Transaction History</div>
    <div class="list-block">
        <ul>
            <li class="item-content" each="{record in transactions}" if="{record.visibility}" onclick="{showRecord}">
                <div class="item-media">
                    <span class="fa-stack fa-lg">
                        <i class="fa fa-circle fa-stack-2x" style="color: #e9873a;"></i>
                        <i if="{!record.direct}" class="fa fa-send fa-stack-1x fa-inverse" style="color: #fff; margin-left: 15px;"></i>
                        <i if="{record.direct}" class="fa fa-money fa-stack-1x fa-inverse" style="color: #fff; margin-left: 17px;"></i>
                    </span>
                </div>
                <div class="item-inner">
                    <div class="item-title-row">
                        <div class="item-title"></div>
                        <div class="item-subtitle" style="color: #555; font-size: 0.8em;">
                            {moment.unix(record.timeStamp).format("YYYY-MM-DD HH:mm")}
                        </div>
                    </div>
                    <div class="item-after">
                        <span if="{!record.direct}" class="badge" style="background: #0A3A5E; width: 10em;"> - {numeral(record.amount).format("0,0.000000000")}</span>
                        <span if="{record.direct}"  class="badge" style="background: #AF8E2E; width: 10em;"> + {numeral(record.amount).format("0,0.000000000")}</span>
                    </div>
                </div>
            </li>
        </ul>
    </div>    
    <style>
        .fa{
            width: 1.5em;
            text-align: center;
            color: #9bb2cc;
        }
        page_form a {
            cursor: pointer;
        }
    </style>
    <script>
        var tag = this;
        tag.cmpName = "tw_ethereum_transactions";
        tag.transactions = [];
        tag.ignoreAddresses = [];
        tag.outcome = 0;
        tag.income = 0;
        tag.on("mount", function(){
            tagRegister[tag.cmpName] = this;
            $.get(API_ENDPOINT+"/cold_wallet_addresses", function(data){
                console.log(data);
                tag.ignoreAddresses = data;
            });
            tag.loadData();
        });
        tag.loadData = function(){
            App.showPreloader();
            $.get(API_ENDPOINT+"/ethereum/wallet/transactions/"+topWebStorage.getItem("UserId"), function(data){
//                console.log(data);
                tag.transactions = data.transactions.reverse();
                tag.address = data.address.toLowerCase();
                tag.ignore = data.ignore.toLowerCase();
                for ( var i = 0 ; i < tag.transactions.length ; ++i ){
                    
                    if (tag.transactions[i].from.toLowerCase() == tag.address)
                        tag.transactions[i].direct = false;
                    else
                        tag.transactions[i].direct = true;
                    tag.transactions[i].amount = tag.transactions[i].value*0.000000000000000001;
                    tag.transactions[i].visibility = true;
                    for ( var j = 0 ; j < tag.ignoreAddresses.length ; ++j ){
                        if ( tag.transactions[i].to.toLowerCase() == tag.ignoreAddresses[j].address.toLowerCase() )
                            tag.transactions[i].visibility = false;
                    }
//                    console.log(tag.transactions[i].from, tag.transactions[i].to, tag.address, tag.transactions[i].direct);
                }
                for ( var i = 0 ; i < tag.transactions.length ; ++i ){
                    if ( tag.transactions[i].visibility == true){
                        
                        if (tag.transactions[i].direct){
                            tag.income += tag.transactions[i].amount*1;
                        }else{
                            tag.outcome += tag.transactions[i].amount*-1;
                        }
                    }
                }
                console.log({"income": tag.income, "outcome": tag.outcome});
                tag.transactions = tag.transactions.sort(function(a,b){
                    return b.timeStamp*1 - a.timeStamp*1;
                });
                tag.update();
                App.hidePreloader();
            });
        }
        tag.showRecord = function(e){
            // console.log(e.item.record);
            var buttons = [
                {
                    text: "[ " + moment(e.item.timeStamp).format("YYYY-MM-DD HH:mm:ss") + " ] " + numeral(e.item.record.amount).format("0,0.000"),
                    label: true
                },
                {
                    text: "<span style='color: "+MAJOR_COLOR+"'>"+"顯示交易明細"+"</span>",
                    onClick: function(){
                        App.alert(e.item.record.from.substring(0, 15) + "...<br/>" + e.item.record.to.substring(0, 15) + "...", "交易明細");
                    }
                },
                {
                    text: "<span style='color: "+MAJOR_COLOR+"'>"+"未到帳回報"+"</span>",
                    onClick: function(){
                        App.confirm("交易金額為："+e.item.record.amount,"問題回報", function(){
                            $.post(API_ENDPOINT+"/notifications/"+topWebStorage.getItem("UserId"), {to_member_id:"AWBW-14988-18633", message: JSON.stringify(e.item.record)}, function(){
                                App.alert("感謝您回報<br/>我們將盡速為您確認到帳資訊。",moment().format("YYYY-MM-DD HH:mm:ss"));
                            });
                        });
                    }
                },
                {
                    text: '取消',
                    color: 'red'
                }
            ];
            App.actions(buttons);;
        }
    </script>
</tw_ethereum_transactions>


